<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-app>


    <LeftDrawer
      v-if="isAuthenticated"
      :show="primaryDrawer.show"
      :selected="mainPanel.what"
      v-on:selected="mainPanel.what=$event"
    />

    <v-app-bar
      :clipped-left="true"
      app
      color="primary"
      dark
    >
      <v-app-bar-nav-icon
        v-if="false"
        @click.stop="primaryDrawer.model = !primaryDrawer.model"
      ></v-app-bar-nav-icon>

      <div class="d-flex align-center">
        <img
          alt="Benchsuite Logo"
          class="shrink mr-2"
          contain
          transition="scale-transition"
          :src="logoSrc"
          width="200"
        />
      </div>

      <v-spacer></v-spacer>

      <LoginMenu/>

    </v-app-bar>

    <v-main>
      <div id="curtain" v-show="$store.state.loading==true"></div>
      <v-container>

        <router-view name="bc"/>

        <router-view
          v-on:listProviders="$router.push('/providers')"
          v-on:newProvider="$router.push('/providers/new')"
          v-on:viewProvider="$router.push('/providers/'+$event.id)"
          v-on:editProvider="$router.push('/providers/'+$event.id+'/edit')"
          v-on:cloneProvider="$router.push('/providers/new?cloneFrom='+$event.id)"
          v-on:editingProviderComplete="$router.push('/providers/'+$event.id)"
          v-on:providerDeleted="$router.push('/providers')"

          v-on:listWorkloads="$router.push('/workloads')"
          v-on:newWorkload="$router.push('/workloads/new')"
          v-on:viewWorkload="$router.push('/workloads/'+$event.id)"
          v-on:editWorkload="$router.push('/workloads/'+$event.id+'/edit')"
          v-on:cloneWorkload="$router.push('/workloads/new?cloneFrom='+$event.id)"
          v-on:specializeWorkload="$router.push('/workloads/new?specialize='+$event.id)"
          v-on:editingWorkloadComplete="$router.push('/workloads/'+$event.id)"
          v-on:workloadDeleted="$router.push('/workloads')"

          v-on:listExecutions="$router.push('/executions')"
          v-on:viewExecution="$router.push('/executions/'+$event.id)"
          v-on:newExecution="$router.push('/executions/new')"
          v-on:cloneExecution="$router.push('/executions/new?cloneFrom='+$event.id)"
          v-on:editingExecutionComplete="$router.push('/executions/'+$event.id)"

          v-on:listSchedules="$router.push('/schedules')"
          v-on:newSchedule="$router.push('/schedules/new')"
          v-on:viewSchedule="$router.push('/schedules/'+$event.id)"
          v-on:editSchedule="$router.push('/schedules/'+$event.id+'/edit')"
          v-on:cloneSchedule="$router.push('/schedules/new?cloneFrom='+$event.id)"
          v-on:editingScheduleComplete="$router.push('/schedules/'+$event.id)"
          v-on:scheduleDeleted="$router.push('/schedules')"

          v-on:title="setTitle($event)"

        />
      </v-container>

      <MainSwitcher
        v-if="false"
        :what="mainPanel.what"
        v-on:up="mainPanel.what='welcome'"
      />


    </v-main>

    <Footer/>

  </v-app>
</template>

<script>
import LeftDrawer from './components/LeftDrawer';
import Footer from './components/Footer';
import MainSwitcher from './components/MainSwitcher';
import LoginMenu from './components/LoginMenu';

import { mapGetters } from "vuex";

export default {
  name: 'App',

  components: {
    LeftDrawer,
    Footer,
    MainSwitcher,
    LoginMenu
  },

  data: () => ({
    primaryDrawer: {
      show: true
    },
    mainPanel: {
      what: "welcome"
    }
  }),


  mounted() {
    this.mainPanel.what = "welcome";
    this.setTitle("");
  },

  methods: {
    setTitle: function(t) {
      document.title = (t ? t+" - " : "") + "Benchsuite" + (this.$brandTitle ? ' - ' + this.$brandTitle : '');
    }
  },

  computed: {
    ...mapGetters(["isAuthenticated"]),
    logoSrc() {
      return require('./assets/' + this.$brandLogo)
    }
  }
};

</script>

<style scoped>
.container {
  max-width: 1024px;
}

#curtain {
  position:absolute;
  top:0px;
  left:0px;
  width:100%;
  height:100%;
  background:white;
  z-index:2;
  fixed:true;
  opacity:0.8;
}

</style>
